#include <atlbase.h>
#include "dx_cap.h"

#include "ui.h"
#include "main.h"
#include "process_frame.h"


#include <windows.h>
#include <objbase.h>

#include <sven_ui/prompt.h>
#include <sven_ui/term.h>
#include <sven_ui/template_command.h>
#include <sven_ui/general_commands.h>
#include <sven_ui/commands.h>
#include <win_input.h>

namespace ui {

using namespace sven_ui;

struct StartCap : sven_ui::TemplateCommand {
	void fun(std::vector<Argument> &args, int n) {
		//sven_ui::general_commands::are_you_sure(g_quit_flag);
		//report("are you sure?");
		//direct_show::GetInterfaces();
		direct_show::CaptureVideo();
		direct_show::reportFilters();
	}

	StartCap() : TemplateCommand("startcap", "summon a direct x filter graph to do our bidding.", "no args", "general") {}
};


struct Exit : sven_ui::TemplateCommand {
	void fun(std::vector<Argument> &args, int n) {
		sven_ui::general_commands::are_you_sure(g_quit_flag);
		report("are you sure?");
	}

	Exit() : TemplateCommand("exit", "quit the program.", "no args", "general") {}
};


struct CT : ColorQuadsTextBox, Term {
	void draw() {
		glScopedAttribs sa(GL_ENABLE_BIT | GL_COLOR_BUFFER_BIT );
	
		glEnable(GL_BLEND);
		glHint(GL_POLYGON_SMOOTH_HINT,GL_NICEST );
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

		//workaround for an nvidia driver bug.
		glBindTexture(GL_TEXTURE_2D,0);

		ColorQuadsTextBox::own_draw();
		BoundedText::own_draw();
	}
};

CT * term;

void init() {

    // Initialize COM
    if(FAILED(CoInitialize(NULL)))
    {
       throw std::runtime_error("CoInitialize Failed!\r\n");

    } 

	term=new CT;

	get_command_manager()->insert(new Exit);
	get_command_manager()->insert(new StartCap);
	process_frame::register_commands();
	direct_show::register_commands();

	push_reporter(term);

	term->set_area(rect(screen_w*.65,screen_h*.3,screen_w*.3,screen_h*.65));
#ifdef _DEBUG
	report("vison_hw -- running in debugging mode");
#else
	report("vison_hw demo -- running in release mode");
#endif
}
void draw() {
	term->draw();
}
void update() {
	int dz=win_tools::g_mouse.getdz();
	term->scroll(dz);
	term->process_keys();
}
void cleanup() {
	direct_show::CloseInterfaces();
	delete term;
	 CoUninitialize();
}

}